/*	
 *	clipdmg.h
 *
 *	P/ECE DMG-CPU Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Thu Jan 15 20:09:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_DMG_H__
#define __CLIP_DMG_H__

/****************************************************************************
 *
 ****************************************************************************/

/* DMG_ASMV{`ǂݍ݂܂B
 * DMG_ASMV{̖`/`ɂC/AZuR[h̐؂ւ́A
 * C\[Xt@C(*.c)ƃAZu\[Xt@C(*.s)QƂ̂ŁA
 * ʂ̃CN[ht@CɕĂ܂B
 * (CL̒`܂ރCN[ht@Ĉ܂܃AZu\[X
 *  CN[hƁAAZuG[ɂȂĂ܂߁B)
 */
#include "clipdmga.h"

/* ̃V{`ƁASĂ̖ߎsg[Xo͂܂B
 * ̃V{`Ȃ΁Aeߎs̓g[Xo͂܂B
 * SĂ̖ߎsg[XƂƂĂxȂ̂ŁAʏ͒`ȂłB
 * ȂÃV{`ĂAŜ̃g[XONwgTRACE_ON=1hȂ΁A
 * g[Xo͍͂s܂B
 */
//#define DMG_TRACE

/********** ȍ~͏Ȃł **********/

/* P/ECEȊOł̓AZuR[h͎gpł܂B
 */
#ifndef PIECE
#undef DMG_ASM
#endif /*PIECE*/

/* AZuR[h͑S߃g[XɑΉĂȂ̂ŁA
 * AZuR[hgp͊mɑS߃g[XOFFɂ܂B
 */
#ifdef DMG_ASM
#undef DMG_TRACE
#endif /*DMG_ASM*/ 

#ifdef DMG_TRACE
#define DMGTRACE	TRACE
#else /*DMG_TRACE*/
#define DMGTRACE	1 ? ((void)0) : TRACE
#endif /*DMG_TRACE*/

/****************************************************************************
 *
 ****************************************************************************/

typedef struct _DMG DMG;

/*
 *	DMGRAO֐̌^`
 */
typedef unsigned char DMGREADPROC (DMG* dmg, unsigned short addr);
typedef          void DMGWRITEPROC(DMG* dmg, unsigned short addr, unsigned char data);

/*
 *	DMGRA
 */
/*typedef*/ struct _DMG {
	/*===== WX^ =====*/
	unsigned short af;		/* + 0, 2 */
	unsigned short bc;		/* + 2, 2 */
	unsigned short de;		/* + 4, 2 */
	unsigned short hl;		/* + 6, 2 */
	unsigned short sp;		/* + 8, 2 */
	unsigned short pc;		/* +10, 2 */
	/*=====  =====*/
	unsigned char ime;		/* +12, 1 */ /* Interrupt Master Enable */
	unsigned char halt;		/* +13, 1 */
	unsigned char _resv1[6];	/* +14, 6 */
	int cycle;			/* +20, 4 */
	/*===== O֐ =====*/
	DMGREADPROC* read;		/* +24, 4 */
	DMGWRITEPROC* write;		/* +28, 4 */
} /*DMG*/;				/* =32    */

/*
 *	CXgNV֐錾
 */
typedef                void DMGOPPROC (DMG* dmg, unsigned char code, int arg);
#define DMGFN_(OP, FN) void dmgop_##FN(DMG* dmg, unsigned char code, int arg);	/* 錾p */
#include "dmg/list.h" /* [dmg.xls]List!C5 */
DMGFN_("CB"   , CB   )
DMGFN_("ERROR", ERROR)
#undef  DMGFN_
#define DMGFN_(FN) void dmgop_##FN(DMG* dmg, unsigned char code, int arg)	/* `p */

/*
 *	IyR[h}bvEj[jbNe[u
 */
typedef struct _DMGOP {
	DMGOPPROC* proc;	/* + 0, 4 */
	unsigned char argc;	/* + 4, 1 */
	unsigned char cycle;	/* + 5, 1 */
	unsigned short name;	/* + 6, 2 dmg_op_name_table[]̕ւ̃ItZbgł */
} DMGOP;			/* = 8    */
#define DMGOP_(CODE, PROC, ARGC, CYCLE, NAME)	{ dmgop_##PROC, 0x##ARGC, 0x##CYCLE, 0x##NAME },
extern const DMGOP dmg_op_table[256/*XX*/];		/* XX */
extern const DMGOP dmg_op_table_CB[256/*XX*/];		/* CB XX */
extern const char dmg_op_name_table[];			/* j[jbNe[u */

/****************************************************************************
 *	֐
 ****************************************************************************/

/* DMGZbgɐݒ肳ADMGRÃCREAD/WRITE̊O֐łB
 * AvP[V璼ڌĂяoƂ͂܂B
 */
unsigned char dmg_internal_read (DMG* dmg, unsigned short addr);
         void dmg_internal_write(DMG* dmg, unsigned short addr, unsigned char data);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* DMGZbg܂B
 * [in]
 *	dmg		DMG\́B
 *	read		CREAD O֐ (NULL:RA֐gp)
 *	write		CWRITEO֐ (NULL:RA֐gp)
 * [note]
 *	* read,writeNULLw肷ƁARÅO֐gp܂B
 *	  RÅO֐́Â悤ȓs܂B
 *	  EREAD	DMG\̂̒64KB̃CzuĂƉ肵ACǂݍ݂܂B
 *	  EWRITE	DMG\̂̒64KB̃CzuĂƉ肵ACɏ݂܂B
 */
void dmg_reset(DMG* dmg, DMGREADPROC* read, DMGWRITEPROC* write);

/* DMGs܂B
 * [in]
 *	dmg		DMG\́B
 *	cycle		sTCNB
 * [note]
 *	* sTCNcycleɒB邩A܂HALT܂Ŏs܂B
 *	  O҂̏ꍇAۂ̎sTCŃAcycleȂ\܂B
 *	  ҂̏ꍇAۂ̎sTCŃAcycleȂȂ\܂B
 *	* ̊֐߂ƂAdmg->cycleɎcsTCNi[Ă܂B
 *	  Ⴆ cycle=100 ŌĂяoAۂɂ 105 TCNsꍇA  dmg->cycle=-5 ƂȂ܂B
 *	  ܂A cycle=100 ŌĂяoA10 TCNs HALT ꍇ́Admg->cycle=90 ƂȂ܂B
 */
void dmg_run(DMG* dmg, int cycle);

/* 荞݃NGXg𔭍s܂B
 * [in]
 *	dmg		DMG\́B
 *	addr		荞݃[`AhXB
 *			DMG-CPUŒ`ĂAhX͎̒ʂłB
 *			0000: RST 00H (荞݂ł͎g܂)
 *			0008: RST 08H (荞݂ł͎g܂)
 *			0010: RST 10H (荞݂ł͎g܂)
 *			0018: RST 18H (荞݂ł͎g܂)
 *			0020: RST 20H (荞݂ł͎g܂)
 *			0028: RST 28H (荞݂ł͎g܂)
 *			0030: RST 30H (荞݂ł͎g܂)
 *			0038: RST 38H (荞݂ł͎g܂)
 *			0040: Vertical Blank Interrupt Start Address
 *			0048: LCDC Status Interrupt Start Address
 *			0050: Timer Overflow Interrupt Start Address
 *			0058: Serial Transfer Completion Interrupt Start Address
 *			0060: High-to-Low of P10-P13 Interrupt Start Address
 * [note]
 *	* 荞݂֎~ĂA荞݃NGXg͖܂B
 *	  荞݃NGXg͕ۗ܂B
 */
void dmg_int(DMG* dmg, unsigned short addr);

/* WG[o͂ɁAWX^_vs܂B
 * [in]
 *	dmg		DMG\́B
 */
void dmg_dump(DMG* dmg);

#ifdef PIECE
/* DMGs܂B(X^bNؑցE)
 * [in]
 *	dmg		DMG\́B
 *	cycle		sTCNB
 * [note]
 *	* dmg_run()Ƃ̈Ⴂ́Å֐̎ŝ݁AX^bN0x0e00`0x1000̍RAMɐ؂芷邱ƂłB
 *	- 0x0e00`0x1000́AP/ECEJ[lIɍRAM[`]ĎgpGAłB
 *	  Ⴆ΁ApceLCDTrans()pceFileWriteSct()ÃGAɍRAM[`]܂B
 *	  IɎgp邽߁AAPIɂ0x0e00`0x1000j󂳂邱Ƃ𗯈ӂĂ΁A
 *	  AvP[VvÖ̗gƂ\łB
 *	- dmg_run()̎́Acallgp񐔂ɑ߁AX^bNRAMɈڂƂɂ͈Ӗ܂B
 *	  dmg_run2()̓X^bN0x1000ɈڂAdmg_run()ĂяoAX^bNɖ߂ďԂ܂B
 *	- X^bNGA0x0e00`0x1000512oCgȂ̂ŁAdmg_run2()̎gpɂ͏܂B
 *	  Edmg_run()ƂĂ΂閽ߏ֐́A傫ȃX^bNt[mۂĂ͂܂B
 *	    eߏ̎ύXꍇ́AӂĂB
 *	  Edmg_run()Ă΂O֐(READ/WRITE)ł́A傫ȃX^bNt[mۂĂ͂܂B
 *	  EX^bN悤Ȋ荞݃[`Ƃ̕p͕słB
 *	    X^bN0x0e00`0x1000ɐ؂ւĂƂɊ荞݂ƁAX^bNӂ鋰ꂪ邩łB
 *	  Edmg_run2()荞݃[`ŌĂяoĂ͂܂B
 *	    OʂŁApceLCDTrans()0x0e00`0x1000GAgpł\邩łB
 *	- ȏ̂悤Ȑ񂪂̂ŁAdmg_run2()̎gpɂ͏[ȒӂKvłB
 *	  dmg_run()gꍇɊrׂāAdmg_run2()gꍇ̌ʂ́A()̍ƂȂ܂B
 */
void dmg_run2(DMG* dmg, int cycle);
#endif /*PIECE*/

#endif /*__CLIP_DMG_H__*/
